#ifndef _DYNAMIXEL_H
#define _DYNAMIXEL_H

#ifdef __cplusplus
extern "C" {
#endif

#include "dynamixel_common.h"

#define     DYN_HEADER_OFF      0
#define     DYN_ID_OFF          2
#define     DYN_LENGTH_OFF      3
#define     DYN_INST_OFF        4
#define     DYN_ERROR_OFF       4
#define     DYN_DATA_OFF        5

/**
 * \brief
 *
 */
void dyn_copy_packet(unsigned char *source, unsigned char *destination);
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_id(unsigned char *packet)
{
  return packet[DYN_ID_OFF];
}
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_length(unsigned char *packet)
{
  return packet[DYN_LENGTH_OFF];
}
/**
 * \brief
 *
 */
static inline TDynInstruction dyn_get_instruction(unsigned char *packet)
{
  return (TDynInstruction)packet[DYN_INST_OFF];
}
/**
 * \brief
 *
 */
unsigned char dyn_check_checksum(unsigned char *packet);

// instruction packet
/*
typedef struct{
  unsigned char header[2];
  unsigned char id;
  unsigned char length;
  unsigned char instruction;
  unsigned char data[MAX_DATA_LENGTH];
  unsigned char checksum;
}TDynInst;
*/
/**
 * \brief
 *
 */
unsigned char dyn_convert_v2_inst_packet(unsigned char *source, unsigned char *destination);
/* ping instruction */
/**
 * \brief
 *
 */
void dyn_init_ping_packet(unsigned char *packet,unsigned char id);
/* read instruction */
/**
 * \brief
 *
 */
void dyn_init_read_packet(unsigned char *packet,unsigned char id,unsigned char address,unsigned char length);
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_read_length(unsigned char *packet)
{
  return packet[DYN_DATA_OFF+1];
}
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_read_address(unsigned char *packet)
{
  return packet[DYN_DATA_OFF];
}
/* write instruction */
/**
 * \brief
 *
 */
void dyn_init_write_packet(unsigned char *packet,unsigned char id,unsigned char address,unsigned char length,unsigned char *data);
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_write_address(unsigned char *packet)
{
  return packet[DYN_DATA_OFF];
}
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_write_length(unsigned char *packet)
{
  return packet[DYN_LENGTH_OFF]-3;
}
/**
 * \brief
 *
 */
unsigned char dyn_get_write_data(unsigned char *packet,unsigned char *data);
/* registered write instruction */
/**
 * \brief
 *
 */
void dyn_init_reg_write_packet(unsigned char *packet,unsigned char id,unsigned char address,unsigned char length,unsigned char *data);
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_reg_write_address(unsigned char *packet)
{
  return packet[DYN_DATA_OFF];
}
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_reg_write_length(unsigned char *packet)
{
  return packet[DYN_LENGTH_OFF]-3;
}
/**
 * \brief
 *
 */
unsigned char dyn_get_reg_write_data(unsigned char *packet,unsigned char *data);
/* action instruction */
/**
 * \brief
 *
 */
void dyn_init_action_packet(unsigned char *packet);
/* reset instruction */
/**
 * \brief
 *
 */
void dyn_init_reset_packet(unsigned char *packet,unsigned char id);
/* sync write instruction */
/**
 * \brief
 *
 */
void dyn_init_sync_write_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned char address,unsigned char length,unsigned char * const data[]);
/**
 * \brief
 *
 */
unsigned char dyn_sync_write_id_present(unsigned char *packet,unsigned char id,unsigned char *address,unsigned char *length,unsigned char *data);
/* bulk read instruction */
/**
 * \brief
 *
 */
void dyn_init_bulk_read_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned char *address,unsigned char *length);
/**
 * \brief
 *
 */
unsigned char dyn_bulk_read_id_present(unsigned char *packet,unsigned char id,unsigned char *address,unsigned char *length);

// status packet
/*
typedef struct{
  unsigned char header[2];
  unsigned char id;
  unsigned char length;
  unsigned char error;
  unsigned char data[MAX_DATA_LENGTH];
  unsigned char checksum;
}TDynStatus;
*/

/**
 * \brief
 *
 */
unsigned char dyn_convert_v2_status_packet(unsigned char *source, unsigned char *destination);
/**
 * \brief
 *
 */
void dyn_init_status_packet(unsigned char *packet,unsigned char id,TDynError error,unsigned char length,unsigned char *data);
/**
 * \brief
 *
 */
static inline TDynError dyn_get_status_error(unsigned char *packet)
{
  return (TDynError)packet[DYN_ERROR_OFF];
}
/* read instruction status packet */
/**
 * \brief
 *
 */
unsigned char dyn_get_read_status_data(unsigned char *packet,unsigned char *data);
/**
 * \brief
 *
 */
static inline unsigned char dyn_get_read_status_id(unsigned char *packet)
{
  return packet[DYN_ID_OFF];
}

#ifdef __cplusplus
}
#endif

#endif
