#ifndef _JOINT_MOTION_H
#define _JOINT_MOTION_H

#ifdef __cplusplus
extern "C" {
#endif

#include "motion_module.h"
#include "memory.h"

#define NUM_JOINT_GROUPS 4

typedef struct{
  TMotionModule mmodule;
  TMemory *memory;
  TMemModule mem_module;
  unsigned short int ram_base_address;
  long int target_angles[DYN_MANAGER_MAX_NUM_DEVICES];//48|16 
  long int target_speeds[DYN_MANAGER_MAX_NUM_DEVICES];//48|16 
  long int target_accels[DYN_MANAGER_MAX_NUM_DEVICES];//48|16 
  long int target_stop_angles[DYN_MANAGER_MAX_NUM_DEVICES];//48|16
  long int current_angles[DYN_MANAGER_MAX_NUM_DEVICES];//48|16 
  long int current_speeds[DYN_MANAGER_MAX_NUM_DEVICES];//48|16 
  char dir[DYN_MANAGER_MAX_NUM_DEVICES];// joint_direction 
  long int motion_period;
  short int motion_period_ms;
  unsigned char stop[NUM_JOINT_GROUPS];
  unsigned char moving[NUM_JOINT_GROUPS];
  unsigned int group_servos[NUM_JOINT_GROUPS];
}TJointMModule;

// public functions
unsigned char joint_motion_init(TJointMModule *joint,TMemory *memory,unsigned short int ram_base_address);
void joint_motion_set_group_servos(TJointMModule *joint,unsigned char group_id,unsigned int servos);
unsigned int joint_motion_get_group_servos(TJointMModule *joint,unsigned char group_id);
void joint_motion_start(TJointMModule *joint,unsigned char group_id);
void joint_motion_stop(TJointMModule *joint,unsigned char group_id);
unsigned char are_joints_moving(TJointMModule *joint,unsigned char group_id);

#ifdef __cplusplus
}
#endif

#endif
