#ifndef _HEAD_TRACKING_H
#define _HEAD_TRACKINH_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f1xx.h"
#include "motion_manager.h"

// public functions
void head_tracking_init(uint16_t period_us);
void head_tracking_set_period(uint16_t period_us);
uint16_t head_tracking_get_period(void);
void head_tracking_start(void);
void head_tracking_stop(void);
uint8_t head_is_tracking(void);
void head_tracking_set_pan_range(int16_t max_angle,int16_t min_angle);
void head_tracking_get_pan_range(int16_t *max_angle,int16_t *min_angle);
void head_tracking_set_pan_pid(uint16_t kp,uint16_t ki,uint16_t kd, uint16_t i_clamp);
void head_tracking_get_pan_pid(uint16_t *kp,uint16_t *ki,uint16_t *kd, uint16_t *i_clamp);
void head_tracking_set_tilt_range(int16_t max_angle,int16_t min_angle);
void head_tracking_get_tilt_range(int16_t *max_angle,int16_t *min_angle);
void head_tracking_set_tilt_pid(uint16_t kp,uint16_t ki,uint16_t kd, uint16_t i_clamp);
void head_tracking_get_tilt_pid(uint16_t *kp,uint16_t *ki,uint16_t *kd, uint16_t *i_clamp);
void head_tracking_set_target_pan(int16_t target);
void head_tracking_set_target_tilt(int16_t target);

// operation functions
uint8_t head_tracking_in_range(unsigned short int address, unsigned short int length);
void head_tracking_process_read_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void head_tracking_process_write_cmd(unsigned short int address,unsigned short int length,unsigned char *data);

// motion manager process function
void head_tracking_process(void);

#ifdef __cplusplus
}
#endif

#endif
