#ifndef _STAIRS_H
#define _STAIRS_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f1xx.h"
#include "motion_manager.h"

// public functions
void stairs_init(uint16_t period_us);
void stairs_set_period(uint16_t period_us);
uint16_t stairs_get_period(void);
void stairs_start(uint8_t up);
void stairs_stop(void);
uint8_t is_climbing_stairs(void);
uint8_t stairs_get_phase(void);

// operation functions
uint8_t stairs_in_range(unsigned short int address, unsigned short int length);
void stairs_process_read_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void stairs_process_write_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
// motion manager interface functions
void stairs_process(void);

#ifdef __cplusplus
}
#endif

#endif
