#ifndef _WALKING_H
#define _WALKING_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f1xx.h"
#include "motion_manager.h"

// public functions
void walking_init(uint16_t period_us);
void walking_set_period(uint16_t period_us);
uint16_t walking_get_period(void);
void walking_start(void);
void walking_stop(void);
uint8_t is_walking(void);

// operation functions
uint8_t walking_in_range(unsigned short int address, unsigned short int length);
void walking_process_read_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void walking_process_write_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
// motion manager interface functions
void walking_process(void);

#ifdef __cplusplus
}
#endif

#endif
