#ifndef USART2_F1_H
#define USART2_F1_H

#include "stm32f1xx_hal.h"
#include "usart_common.h"
#include "comm.h"

/* public functions */
void usart2_init(TComm *comm_dev,UART_InitTypeDef *conf,TUSART_IRQ_Priorities *priorities);
void usart2_config(TComm *comm_dev,UART_InitTypeDef *conf);
void usart2_set_priorities(TComm *comm_dev,TUSART_IRQ_Priorities *priorities);
void usart2_set_baudrate(TComm *comm_dev,unsigned int baudrate);
/* IRQ functions */
unsigned char usart2_send_irq(unsigned char first_byte);
unsigned char usart2_enable_tx_irq(void);
unsigned char usart2_receive_irq(void);
unsigned char usart2_cancel_receive_irq(void);
/* DMA functions */
unsigned char usart2_send_dma(unsigned char *data,unsigned short int length);
unsigned char usart2_receive_dma(unsigned char *data,unsigned short int length);
unsigned char usart2_cancel_receive_dma(void);

#endif
