#ifndef USART3_F1_H
#define USART3_F1_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f1xx_hal.h"
#include "usart_common.h"
#include "comm.h"


/* public functions */
void usart3_init(TComm *comm_dev,USART_InitTypeDef *conf,TUSART_IRQ_Priorities *priorities);
void usart3_config(TComm *comm_dev,USART_InitTypeDef *conf);
void usart3_set_priorities(TComm *comm_dev,TUSART_IRQ_Priorities *priorities);
void usart3_set_baudrate(TComm *comm_dev,unsigned int baudrate);
/* IRQ functions */
unsigned char usart3_send_irq(unsigned char first_byte);
unsigned char usart3_enable_tx_irq(void);
unsigned char usart3_receive_irq(void);
unsigned char usart3_cancel_receive_irq(void);
void USART_IRQHandler(void);
/* DMA functions */
unsigned char usart3_send_dma(unsigned char *data,unsigned short int length);
unsigned char usart3_receive_dma(unsigned char *data,unsigned short int length);
unsigned char usart3_cancel_receive_dma(void);
void USART_DMA_TX_IRQHandler(void);
void USART_DMA_RX_IRQHandler(void);

#ifdef __cplusplus
}
#endif

#endif
