#ifndef _MEMORY_H
#define _MEMORY_H

#ifdef __cplusplus
extern "C" {
#endif

#include "mem_module.h"

#define MAX_NUM_MEM_MODULES       16
#ifndef EEPROM_SIZE
  #define EEPROM_SIZE               32
#endif
#ifndef RAM_SIZE
  #define RAM_SIZE                  256
#endif

typedef struct
{
  unsigned char num_mem_modules;
  TMemModule *mem_modules[MAX_NUM_MEM_MODULES];
  unsigned short int (*eeprom_write_data)(unsigned short int address,unsigned short int data);
  unsigned short int (*eeprom_read_data)(unsigned short int address,unsigned short int *data);
  unsigned char data[RAM_SIZE];
  unsigned char total_eeprom;
  unsigned char total_ram;
}TMemory;

void mem_init(TMemory *memory);
void mem_initialize_data(TMemory *memory);
unsigned char mem_add_module(TMemory *memory, TMemModule *module);
void mem_do_write(TMemory *memory,unsigned short int start_address,unsigned short int length,unsigned char *data);
void mem_do_read(TMemory *memory,unsigned short int start_address,unsigned short int length,unsigned char *data);

#ifdef __cplusplus
}
#endif

#endif
