#ifndef _RAM_H
#define _RAM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "memory.h"

#define      RAM_SUCCESS       0
#define      RAM_BAD_ADDRESS  -1
#define      RAM_WRITE_ERROR  -2
#define      RAM_BAD_BIT      -3
#define      RAM_BAD_ACCESS   -4

unsigned char ram_init(TMemory *memory);
static inline void ram_read_byte(TMemory *memory,unsigned short int address, unsigned char *data)
{
  (*data)=memory->data[address];
}
static inline void ram_read_word(TMemory *memory,unsigned short int address, unsigned short int *data)
{
  (*data)=memory->data[address];
  (*data)+=memory->data[address+1]*256;
}
unsigned char ram_read_table(TMemory *memory,unsigned short int address, unsigned short int length,unsigned char *data);
unsigned char ram_set_bit(TMemory *memory,unsigned short int address, unsigned char bit);
unsigned char ram_clear_bit(TMemory *memory,unsigned short int address, unsigned char bit);
unsigned char ram_write_byte(TMemory *memory,unsigned short int address, unsigned char data);
unsigned char ram_write_word(TMemory *memory,unsigned short int address, unsigned short int data);
unsigned char ram_write_table(TMemory *memory,unsigned short int address, unsigned short int length,unsigned char *data);
static inline unsigned char ram_in_range(unsigned short int reg,unsigned short int address,unsigned short int length)
{
  if(reg>=address && reg<(address+length))
    return 0x01;
  else
    return 0x00;
}
unsigned char ram_in_window(unsigned short int start_reg,unsigned short int reg_length,unsigned short int start_address,unsigned short int address_length);

#ifdef __cplusplus
}
#endif

#endif
