#include "stm32_time.h"

/* public functions */
void time_init(TTime *time,int counts_per_us,unsigned long long int(*get_time)(void))
{
  time->target_time=(unsigned long long int)-1;
  time->counts_per_us=counts_per_us;
  time->get_time=get_time;
}

void time_set_timeout(TTime *time,long timeout_us)
{
  unsigned long long int counts;

  counts=time->get_time();
  time->target_time=counts+timeout_us*time->counts_per_us;
}

unsigned char time_is_timeout(TTime *time)
{
  if(time->target_time!=(unsigned long long int)-1)
  {
    if(time->get_time()>time->target_time)
    {
      time->target_time=(unsigned long long int)-1;
      return 0x01;
    }
    else
      return 0x00;
  }
  else
    return 0x00;
}

void time_delay_us(TTime *time,int delay_us)
{
  time_set_timeout(time,delay_us);
  while(!time_is_timeout(time));
  time->target_time=(unsigned long long int)-1;
}

void time_delay_ms(TTime *time,int delay_ms)
{
  time_set_timeout(time,delay_ms*1000);
  while(!time_is_timeout(time));
  time->target_time=(unsigned long long int)-1;
}

void time_delay_s(TTime *time,int delay_s)
{
  time_set_timeout(time,delay_s*1000000);
  while(!time_is_timeout(time));
  time->target_time=(unsigned long long int)-1;
}
